/*
 * $Id: globals.h,v 1.13 2002/04/16 03:18:34 phj Exp $
 */
#ifndef CHINPUT_GLOBAL_H
#define	CHINPUT_GLOBAL_H

#include <stdio.h>
#include <stdlib.h>
#include <err.h>
#include <X11/Xlib.h>
#include <X11/Xlocale.h>
#include <X11/Xutil.h>
#include <X11/Xos.h>
#include <X11/keysym.h>

#include "db_util.h"
#include "local_types.h"
#include <mysql/mysql.h>

#define	WIN_MIN_WIDTH		640
#define	WIN_MIN_HEIGHT		40
#define	WIN_MIN_BORDER		2
#define WIN_DEFAULT_X		200
#define WIN_DEFAULT_Y		100

#define	WIN_HEAD_X		0
#define WIN_HEAD_Y              16
#define WIN_PY_X	        96
#define WIN_PY_Y                16
#define WIN_SELECT_X	        0
#define WIN_SELECT_Y            36



#define	WIN_NAME	"Chinput2"

#define INPUT_WIN_NAME	"w_input"

#define	FONT_GB		"-isas-fangsong ti-medium-r-normal--16-160-72-72-c-160-gb2312.1980-0"
#define FONT_GB_SUN     "-sun-song-medium-r-normal--16-140-75-75-c-140-gb2312.1980-0"
#define	FONT_ROMAN	"8x16"

#define SPACE ' '

#define BELL_VOLUMN 50

/* IM part */
#define DEFAULT_IM_NAME	"Chinput"

#define GL_TYPE 0
#define GR_TYPE 1

#define	ERR_NO	(-1)

#define YES     1
#define NO      0

#define MAX_HANZI_LEN   64

/*
 * Does MAX_PHRASE_NUM 256  enough ? I'm not sure! 
 * but it should not less than 150 at least for any 
 * hanzi with the same PinYin.
 */
#define MAX_PHRASE_NUM      256
#define MAX_DISP_PHRASE_NUM 7

#define DEFAULT_LOCALE "zh_CN,zh_TW"
#define BIG5_LOCALE    "zh_TW"
#define GB_LOCALE      "zh_CN"

#define GB_LC_CTYPE   "zh_CN.EUC"
#define BIG5_LC_CTYPE "zh_TW.Big5"

#define GB_ENCODING   0
#define BIG5_ENCODING  1

#ifdef MAIN_PROGRAM
#define DECLARE
#else
#define DECLARE extern
#endif


DECLARE char   *progname;
DECLARE char   *display_name;
DECLARE Display *display;
DECLARE int     screen;
DECLARE Window  w_input;
DECLARE XFontStruct *gb_font, *roman_font;
DECLARE XCharStruct gb_font_info, roman_font_info;
DECLARE GC      gb_gc, roman_gc;
DECLARE int     font_type;

DECLARE u_char_8 select_area[WIN_MIN_WIDTH];
DECLARE int     ch2b_select_pos;
DECLARE char    str_pinyin_area[MAX_PINYIN_LEN];
DECLARE char    str_pinyin[MAX_PINYIN_LEN];
DECLARE int     str_pinyin_pos;
DECLARE u_char_8 commit_str[MAX_HANZI_CHAR_NUMBER*2+1];
DECLARE int     last_selected_pinyin_pos;

DECLARE u_char_8   phrase[MAX_PHRASE_NUM][MAX_PINYIN_LEN];
DECLARE int     phrase_num;
DECLARE int     phrase_base_num;
DECLARE int     phrase_top_num;
DECLARE int     phrase_num_offset;

DECLARE char    hostname[MAX_CONFIG_VARS_LEN];
DECLARE char    username[MAX_CONFIG_VARS_LEN];
DECLARE char    password[MAX_CONFIG_VARS_LEN];
DECLARE char    database[MAX_CONFIG_VARS_LEN];
DECLARE char    pydb_table[MAX_CONFIG_VARS_LEN];
DECLARE int     port;
DECLARE int     max_latest_len;
DECLARE int     max_words_len;
DECLARE int     need_update;
DECLARE int     encoding; 

#endif










