/*
 * $Id: pydb.c,v 1.23 2002/04/17 02:58:10 phj Exp $
 */
#include "chinput2.h"
#include "globals.h"
#include "pydb.h"
#include "util.h"
#include "db_util.h"


extern MYSQL pydb;


void
adjust_code_type(unsigned char *hanzi)
{
  register unsigned char *p;

  if (font_type == GL_TYPE) {
    for (p = hanzi; *p; p++)
      if (*p > 0x80)
	*p -= 0x80;
  }
}

/*
 * phrase_base_num
 * phrase_num_offset
 * phrase_num
 * phrase_top_num
 */
void
assemble_select_area(void)
{
  unsigned char   buf[MAX_PINYIN_LEN];
  int             offset;
  int             len;
  int             i;

  if (str_pinyin[0] == '\0')
    return;
  offset = 0;
#if 0
  printf("phrase_num=%d\n",phrase_num);
#endif
  phrase_base_num=phrase_num_offset*MAX_DISP_PHRASE_NUM;
  if( phrase_base_num ){
    switch((phrase_num-phrase_base_num)/MAX_DISP_PHRASE_NUM){
    case 0:
      phrase_top_num=phrase_num;
      break;
    default:
      phrase_top_num=phrase_base_num+MAX_DISP_PHRASE_NUM;
      break;
    }
  }else{
    if( phrase_num > MAX_DISP_PHRASE_NUM)
      phrase_top_num=MAX_DISP_PHRASE_NUM;
    else
      phrase_top_num=phrase_num;
  }
  if( phrase_top_num  == 0)
    return;
  for (i = phrase_base_num; 
       i < phrase_top_num; ++i) {
    sprintf(buf, " %d.", i-phrase_base_num+1);
    len = strlen(buf);
    XDrawImageString(display, w_input, roman_gc, 
		     WIN_SELECT_X + offset, WIN_SELECT_Y,
		     buf, len);
    offset += len * roman_font_info.width;
    sprintf(buf, "%s", phrase[i]);
    len = strlen(buf);
    adjust_code_type(buf);
    XDrawImageString16(display, w_input, gb_gc, 
		       WIN_SELECT_X + offset, WIN_SELECT_Y, 
		       (XChar2b *) buf, len / 2);
    offset += len / 2 * gb_font_info.width;
  }
  if (offset < WIN_MIN_WIDTH) {
    len = (WIN_MIN_WIDTH - offset) / roman_font_info.width;
    XDrawImageString(display, w_input, roman_gc, WIN_SELECT_X + offset, WIN_SELECT_Y, select_area, len);
  }
}


void
keep_alive(int sig)
{
    db_close(&pydb);
    db_connect(&pydb,hostname,username,password,database,port,NULL,0);
}


     
static int 
exec_query_and_udpate_phrase(int query_type,int is_single_hanzi,char *pinyin_buf)
{
  int ret,i;
  char sql[256];
  MYSQL_RES *res;
  MYSQL_ROW row;

  /*
   * query static items.
   */
#define SQL_STATIC_SHORT "SELECT HIGH_PRIORITY hanzi FROM %s  WHERE pinyin='%s' ORDER BY freq DESC LIMIT %d"

/* the LIKE option made the query terribly slowly,so drop them.
#define SQL_STATIC_LONG  "SELECT HIGH_PRIORITY hanzi FROM %s  WHERE pinyin LIKE '%s%%' ORDER BY freq DESC LIMIT %d"
*/
  /*
   * query recent items.
   */
#define SQL_RECENT_SHORT "SELECT HIGH_PRIORITY hanzi FROM %s WHERE pinyin='%s' ORDER BY last_used DESC LIMIT %d"

/* why not use it? see the reason as the above LONG SELECT sentence.
#define SQL_RECENT_LONG  "SELECT HIGH_PRIORITY hanzi FROM %s WHERE pinyin LIKE '%s%%' ORDER BY last_used DESC LIMIT %d"
*/
  switch(query_type){
  case STATIC_ITEMS:
    if( is_single_hanzi == 1){
      sprintf(sql,SQL_STATIC_SHORT,pydb_table,pinyin_buf,MAX_PHRASE_NUM);
    }else{  
      if( max_words_len <= MAX_PHRASE_NUM)
	sprintf(sql,SQL_STATIC_SHORT,pydb_table,pinyin_buf,max_words_len);
      else
	sprintf(sql,SQL_STATIC_SHORT,pydb_table,pinyin_buf,MAX_PHRASE_NUM);
    }
    break;
  case RECENT_ITEMS:
    if( is_single_hanzi == 1) 
      sprintf(sql,SQL_RECENT_SHORT,pydb_table,pinyin_buf,max_latest_len);
    else  
      sprintf(sql,SQL_RECENT_SHORT,pydb_table,pinyin_buf,max_latest_len);
    break;
  }
#if 0
  printf("sql=[%s]\n",sql);
#endif
  ret=mysql_real_query(&pydb,sql,strlen(sql));
  if(ret)
    warn("error in mysql_real_query()\n");
  res=(MYSQL_RES *)mysql_store_result(&pydb);
  if(!res)
    warn("Error in mysql_store_result()\n");
  ret=mysql_num_rows(res);
  i=0;
  if(ret){
    while((row=mysql_fetch_row(res)) && (phrase_num+i)< MAX_PHRASE_NUM){
      strcpy(phrase[i+phrase_num],row[0]);
#if 0
      printf("CUR=%d.hanzi=[%s]\n",i,row[0]);
#endif
      ++i;
    }
  }
  mysql_free_result(res);
  
#if 0
  printf("i=%d\n",i);
#endif
  return i;
}


/*
 * Return selected rows and set the last position of str_pinyin of which has been used.
 */
static int
find_last_pos_has_phrase(int query_type,int is_single_hanzi,char *pinyin_buf)
{
  static char buf[MAX_PINYIN_LEN];
  int pos,last_pos=0,rows;

  strcpy(buf,str_pinyin);
  pos=strlen(buf);
  while(pos > 0 ){
    last_pos=pos;
#if 0
    printf("pos=%d\n",pos);
#endif
    if(is_last_pinyin_valid(buf,&is_single_hanzi,&pos)){
      rows=exec_query_and_udpate_phrase(query_type,is_single_hanzi,buf);
      if(rows) {
	last_selected_pinyin_pos=last_pos;
	return rows;
      }else{
	buf[pos]='\0';
      }
    }else{
      last_selected_pinyin_pos=0;
      return 0;
    }
  }
  last_selected_pinyin_pos=0;
  return 0;
}


static int 
get_items(int query_type,int is_single_hanzi)
{
  return find_last_pos_has_phrase(query_type,is_single_hanzi,str_pinyin);
}

#if 1   /* is_last_pinyin_valid */

#define TOTAL_KEYWORDS 402
#define MIN_WORD_LENGTH 1
#define MAX_WORD_LENGTH 6
#define MIN_HASH_VALUE 2
#define MAX_HASH_VALUE 487

#ifdef __GNUC__
__inline
#else
#ifdef __cplusplus
inline
#endif
#endif
static unsigned int
hash (str, len)
     register const char *str;
     register unsigned int len;
{
  static const unsigned short asso_values[] =
    {
      488, 488, 488, 488, 488, 488, 488, 488, 488, 488,
      488, 488, 488, 488, 488, 488, 488, 488, 488, 488,
      488, 488, 488, 488, 488, 488, 488, 488, 488, 488,
      488, 488, 488, 488, 488, 488, 488, 488, 488, 488,
      488, 488, 488, 488, 488, 488, 488, 488, 488, 488,
      488, 488, 488, 488, 488, 488, 488, 488, 488, 488,
      488, 488, 488, 488, 488, 488, 488, 488, 488, 488,
      488, 488, 488, 488, 488, 488, 488, 488, 488, 488,
      488, 488, 488, 488, 488, 488, 488, 488, 488, 488,
      488, 488, 488, 488, 488, 488, 488,  70,  48, 155,
      120,  14, 241,   5, 200,  30, 122,  82,  95, 243,
        0, 235, 153, 245,  38,   2, 165, 216,   0, 105,
       78,  46, 197, 488, 488, 488, 488, 488, 488, 488,
      488, 488, 488, 488, 488, 488, 488, 488, 488, 488,
      488, 488, 488, 488, 488, 488, 488, 488, 488, 488,
      488, 488, 488, 488, 488, 488, 488, 488, 488, 488,
      488, 488, 488, 488, 488, 488, 488, 488, 488, 488,
      488, 488, 488, 488, 488, 488, 488, 488, 488, 488,
      488, 488, 488, 488, 488, 488, 488, 488, 488, 488,
      488, 488, 488, 488, 488, 488, 488, 488, 488, 488,
      488, 488, 488, 488, 488, 488, 488, 488, 488, 488,
      488, 488, 488, 488, 488, 488, 488, 488, 488, 488,
      488, 488, 488, 488, 488, 488, 488, 488, 488, 488,
      488, 488, 488, 488, 488, 488, 488, 488, 488, 488,
      488, 488, 488, 488, 488, 488, 488, 488, 488, 488,
      488, 488, 488, 488, 488, 488
    };
  return len + asso_values[(unsigned char)str[len - 1]] + asso_values[(unsigned char)str[0]];
}

#ifdef __GNUC__
__inline
#endif
const char *
in_word_set (str, len)
     register const char *str;
     register unsigned int len;
{
  static const char * const wordlist[] =
    {
      "nv",
      "nan",
      "nin",
      "nen",
      "nian",
      "nuan",
      "san",
      "sun",
      "sen",
      "shan",
      "suan",
      "shun",
      "shen",
      "ng",
      "shuan",
      "gan",
      "gun",
      "gen",
      "guan",
      "nong",
      "ning",
      "neng",
      "nang",
      "niang",
      "sang",
      "song",
      "seng",
      "shang",
      "sheng",
      "shuang",
      "gang",
      "gong",
      "geng",
      "guang",
      "en",
      "ne",
      "nie",
      "nve",
      "se",
      "she",
      "ge",
      "e",
      "ni",
      "nai",
      "nei",
      "si",
      "sai",
      "sui",
      "shi",
      "shai",
      "shui",
      "shuai",
      "gai",
      "gui",
      "gei",
      "guai",
      "ran",
      "run",
      "ren",
      "ruan",
      "rang",
      "rong",
      "reng",
      "yan",
      "yun",
      "yin",
      "yuan",
      "ban",
      "bin",
      "ben",
      "bian",
      "er",
      "re",
      "yang",
      "yong",
      "ying",
      "bang",
      "bing",
      "beng",
      "ye",
      "yue",
      "bie",
      "ri",
      "rui",
      "an",
      "na",
      "sa",
      "sha",
      "shua",
      "ga",
      "ang",
      "gua",
      "yi",
      "bi",
      "bai",
      "bei",
      "xin",
      "xun",
      "xian",
      "xuan",
      "kan",
      "kun",
      "ken",
      "kuan",
      "xing",
      "xiang",
      "xiong",
      "kang",
      "kong",
      "keng",
      "kuang",
      "xie",
      "xue",
      "lv",
      "ke",
      "lan",
      "lun",
      "lin",
      "lian",
      "luan",
      "ai",
      "lang",
      "long",
      "ling",
      "leng",
      "liang",
      "wan",
      "wen",
      "xi",
      "le",
      "lie",
      "lve",
      "wang",
      "weng",
      "kai",
      "kui",
      "kuai",
      "ya",
      "ba",
      "dan",
      "dun",
      "dian",
      "duan",
      "jin",
      "jun",
      "jian",
      "juan",
      "li",
      "lai",
      "lei",
      "dang",
      "dong",
      "ding",
      "deng",
      "jing",
      "jiang",
      "jiong",
      "de",
      "die",
      "wai",
      "wei",
      "jie",
      "jue",
      "a",
      "xia",
      "di",
      "dai",
      "dui",
      "ji",
      "ka",
      "kua",
      "pan",
      "pin",
      "pen",
      "pian",
      "can",
      "cun",
      "cen",
      "chan",
      "cuan",
      "chun",
      "chen",
      "chuan",
      "pang",
      "ping",
      "peng",
      "cang",
      "cong",
      "ceng",
      "chang",
      "chong",
      "cheng",
      "chuang",
      "la",
      "tan",
      "tun",
      "tian",
      "tuan",
      "pie",
      "ce",
      "che",
      "tang",
      "tong",
      "ting",
      "teng",
      "wa",
      "te",
      "tie",
      "pi",
      "pai",
      "pei",
      "ci",
      "cai",
      "cui",
      "chi",
      "chai",
      "chui",
      "chuai",
      "da",
      "dia",
      "jia",
      "ti",
      "tai",
      "tui",
      "zan",
      "zun",
      "zen",
      "zhan",
      "zuan",
      "zhun",
      "zhen",
      "zhuan",
      "han",
      "hun",
      "hen",
      "huan",
      "zang",
      "zong",
      "zeng",
      "zhang",
      "zhong",
      "zheng",
      "zhuang",
      "hang",
      "hong",
      "heng",
      "huang",
      "ze",
      "zhe",
      "eh",
      "he",
      "nu",
      "niu",
      "nou",
      "su",
      "shu",
      "sou",
      "shou",
      "gu",
      "gou",
      "pa",
      "ca",
      "cha",
      "zi",
      "zai",
      "zui",
      "zhi",
      "zei",
      "zhai",
      "zhui",
      "zhuai",
      "hai",
      "hui",
      "hei",
      "huai",
      "ta",
      "nao",
      "nuo",
      "niao",
      "sao",
      "suo",
      "shao",
      "shuo",
      "gao",
      "guo",
      "fan",
      "fen",
      "man",
      "min",
      "men",
      "mian",
      "qin",
      "qun",
      "qian",
      "quan",
      "fang",
      "feng",
      "mang",
      "ming",
      "meng",
      "qing",
      "qiang",
      "qiong",
      "ru",
      "rou",
      "me",
      "mie",
      "qie",
      "que",
      "yu",
      "you",
      "bu",
      "za",
      "zha",
      "zhua",
      "ha",
      "hua",
      "fei",
      "mi",
      "mai",
      "mei",
      "rao",
      "ruo",
      "qi",
      "yo",
      "yao",
      "bo",
      "bao",
      "biao",
      "xu",
      "xiu",
      "ku",
      "kou",
      "ao",
      "fa",
      "lu",
      "liu",
      "lou",
      "ma",
      "xiao",
      "qia",
      "kao",
      "kuo",
      "wu",
      "lao",
      "luo",
      "liao",
      "du",
      "diu",
      "dou",
      "ju",
      "jiu",
      "wo",
      "dao",
      "duo",
      "diao",
      "jiao",
      "pu",
      "pou",
      "cu",
      "chu",
      "cou",
      "chou",
      "tu",
      "tou",
      "po",
      "pao",
      "piao",
      "cao",
      "cuo",
      "chao",
      "chuo",
      "tao",
      "tuo",
      "tiao",
      "zu",
      "zhu",
      "zou",
      "zhou",
      "hu",
      "hou",
      "zao",
      "zuo",
      "zhao",
      "zhuo",
      "hao",
      "huo",
      "ou",
      "fu",
      "fou",
      "mu",
      "miu",
      "mou",
      "qu",
      "qiu",
      "o",
      "fo",
      "mo",
      "mao",
      "miao",
      "qiao",
      "m"
    };

  static const short lookup[] =
    {
      -372,   -3,    0, -907, -905, -903, -901, -899,
      -897, -895,   23, -893, -891,   29, -403,   33,
      -427, -425,   38,   39,   -1,   40, -366,   -2,
      -368,   -2,   -1, -359,   -2,   41, -356,   -3,
        42, -430,   45, -433, -888,   51, -448,   55,
        -1, -446,   59, -346,   -3, -350,   -3, -879,
        -1, -877,   66, -471,   70,   -1, -469, -463,
        -1, -461, -326,   -3, -329,   -3,   79,   80,
        -1,   81, -331,   -2, -335,   -3,   82,   83,
      -875,   -1,   86,   87,   88,   89, -872,   -1,
        93, -870, -486, -304,   -2, -859,  103,  104,
      -492, -297,   -2, -496,  110, -295,   -3, -857,
        -1,  113, -854, -503, -284,   -2,  120,   -1,
      -509,  125, -281,   -4, -852,   -1,  128,  129,
      -850,   -1, -848, -524,  136,   -1,  137,   -1,
       138, -268,   -2, -835, -833, -831, -829,  147,
      -551, -549,   -1,  154, -536, -247,   -2,   -1,
       157,  158, -547, -545,   -1,  163, -241,   -2,
      -243,   -2, -252,   -4, -254,   -2,   -1,  164,
       165, -827, -825,  170, -816,  174, -814, -812,
       182,   -1, -810,   -1, -804, -802,  192,  193,
      -586, -581,  198,  199,  200,   -1, -578, -201,
        -4,  205, -206,   -2,   -1,  206,  207, -208,
        -2,  208, -790,  211, -788, -783,  217,   -1,
       218,  219,   -1,  220,   -1,  221, -781,   -1,
      -771, -769,  231, -767,  235,   -1, -758, -756,
       242, -614,  246, -159,   -3,  247,  248,   -1,
      -754,   -1,  251, -752,  254, -750,  257,  258,
       259,  260,   -1,  261,  262,  263, -748, -733,
       270, -638,  274, -131,   -3,  275, -731,  278,
      -713, -711,   -1, -707, -705,   -1, -701,  290,
      -697, -695, -693,   -1, -691,   -1,  300, -683,
       303,  304,   -1,  305,  306,   -1, -670,   -1,
       309,  310,  311,  -95,   -2,  312,  313,  314,
       315,  316,  317,  318, -681,  323,  -83,   -4,
      -101,   -2,   -1,  324,  325,  326,  327,  328,
      -105,   -3, -107,   -2, -109,   -2, -111,   -2,
       329,  330, -115,   -3,  331,  332, -117,   -2,
      -119,   -2,   -1,  333, -121,   -2, -123,   -2,
        -1, -729, -727,  338,   -1,  339,  340,   -1,
      -724,  -61,   -2,  343,  -66,   -2,  -68,   -2,
      -126,   -2, -134,   -2,   -1, -738,  346,  -58,
        -2,   -1,  347, -746,  350,  351,  352,  -54,
        -2, -138,   -4, -147,   -2, -150,   -2, -153,
        -2, -163,   -3, -166,   -3,   -1, -765,  355,
        -1,  356,  -49,   -2, -170,   -3, -175,   -4,
      -178,   -3,   -1,  357,  358,  359, -779,  362,
       -42,   -2, -180,   -2, -187,   -2,   -1,  363,
       364, -190,   -3, -193,   -2,   -1,  365,  366,
       367, -800, -798,  -32,   -2,  -34,   -2, -213,
        -3, -216,   -3, -808,  374,  -30,   -2, -219,
        -3, -224,   -4, -227,   -3, -231,   -3,  375,
      -823,  378,  379,  380,  -26,   -2, -234,   -2,
      -236,   -2, -257,   -2, -259,   -2, -261,   -2,
      -263,   -2,   -1, -846, -844,   -1, -842,  -17,
        -2,  -19,   -2,  -21,   -2, -270,   -2, -272,
        -2, -276,   -2, -288,   -4,  387, -291,   -2,
      -302,   -3,   -1,  388,  389,  390, -868,  393,
       394,  -11,   -2, -308,   -4, -312,   -3,  395,
      -318,   -2, -339,   -3, -342,   -3,  396,   -1,
       397,  398,  399,   -1,  400, -353,   -2,  401,
      -375,   -2, -378,   -3, -384,   -5, -387,   -3,
      -389,   -2, -393,   -4, -396,   -3, -398,   -2,
      -401,   -3
    };

  if (len <= MAX_WORD_LENGTH && len >= MIN_WORD_LENGTH)
    {
      register int key = hash (str, len);

      if (key <= MAX_HASH_VALUE && key >= 0)
        {
          register int index = lookup[key];

          if (index >= 0)
            {
              register const char *s = wordlist[index];

              if (*str == *s && !strcmp (str + 1, s + 1))
                return s;
            }
          else if (index < -TOTAL_KEYWORDS)
            {
              register int offset = - 1 - TOTAL_KEYWORDS - index;
              register const char * const *wordptr = &wordlist[TOTAL_KEYWORDS + lookup[offset]];
              register const char * const *wordendptr = wordptr + -lookup[offset + 1];

              while (wordptr < wordendptr)
                {
                  register const char *s = *wordptr;

                  if (*str == *s && !strcmp (str + 1, s + 1))
                    return s;
                  wordptr++;
                }
            }
        }
    }
  return 0;
}

/*  
 * A trick,assuming that only the last pinyin_phrase would be error.
 */
int 
is_last_pinyin_valid(char *pinyin,int *is_single_hanzi,int *last_valid_position)
{
  int i,flag,len,pos,copy_len;
  char *end;
  char buf[MAX_SINGLE_HANZI_PINYIN_LEN+1];

  i=0;
  pos=0;
  flag=0;
  len=0;
  copy_len=0;

  len=strlen(pinyin);
  end=(char *)(pinyin+len);
  if(len > MAX_SINGLE_HANZI_PINYIN_LEN)
    copy_len=MAX_SINGLE_HANZI_PINYIN_LEN;
  else
    copy_len=len;

  strncpy(buf,(char *)(end-copy_len),copy_len);
  buf[copy_len]='\0';
  for(i=0;i<copy_len;++i){
    if( in_word_set(buf+i,copy_len-i) != NULL){
      flag=1;
      break;
    }
  }

  if(flag == 1)
    pos=(int)((char *)(end-copy_len+i)-pinyin);
  else
    pos=(int)((char *)(end-copy_len)-pinyin);
  
  if( last_valid_position != NULL)
    *last_valid_position=pos;

  if( is_single_hanzi != NULL){
    if( pos == 0){
      *is_single_hanzi=1;
    }else{
      *is_single_hanzi=0;
    }
  }
  if(flag == 1)
    return 1;
  else
    return 0;
}
#endif /* is_last_pinyin_valid */

int
get_select(void)
{
  int is_single_hanzi=0;

  if( is_last_pinyin_valid(str_pinyin,&is_single_hanzi,NULL) != 0){
    if(max_latest_len){
      phrase_num=get_items(RECENT_ITEMS,is_single_hanzi);
      if( phrase_num < max_latest_len )
	return phrase_num;
      if(phrase_num < MAX_PHRASE_NUM)
	phrase_num+=get_items(STATIC_ITEMS,is_single_hanzi);

    }else{
      phrase_num=get_items(STATIC_ITEMS,is_single_hanzi);
    }
    return phrase_num;
  }else{
    return 0;
  }
}

/*
 * This function can only be called from the NEED_COMMIT action.
 * and the commit_str should only contain HanZi.
 */
void
update_pydb(void)
{
  static unsigned char last[MAX_HANZI_CHAR_NUMBER*2*2+1];
  static int flag=1;
  static int len_of_last;

  if( !need_update)
    return ;
  if(commit_str == NULL || phrase_num==0 )
    return;
  if(flag){
    flag=0;
    memset(last,0,sizeof(last));
  }
 
  strcat(last,commit_str);
  len_of_last=strlen(last);
  if( len_of_last < MAX_HANZI_CHAR_NUMBER*2)
    return;
  do{
    (void)add_item(last,HIGH_PRIORITY);
    memmove(last,last+HANZI_CHAR_WIDTH,len_of_last+1-HANZI_CHAR_WIDTH);
    len_of_last=strlen(last);
#if 0
    fprintf(stderr,"A.last=[%s],commmit_str=[%s]\n",last,commit_str);
#endif
  }while(len_of_last >=MAX_HANZI_CHAR_NUMBER*2);
}

void
init_pydb(void)
{
  init_py_ref_db(&pydb,0);
  db_connect(&pydb,hostname,username,password,database,port,NULL,0);
}

