#include <err.h>
#include <stdio.h>
#include <string.h>
#include "globals.h"

#define CHAR_TYPE 0
#define INT_TYPE  1

static FILE	*in;

void
get_tag_content(const char *tag,int  t,void *p)
{
	char buf[512];
	char tag_tmp[512];
	static char item[512];

	rewind(in);
	while(fgets(buf,sizeof(buf),in)){
		sscanf(	buf,"%s%s",tag_tmp,item);
		if( strcasecmp(tag,tag_tmp))
			continue;
		switch(t){
		case CHAR_TYPE:
		  strcpy((unsigned char *)p,item);
		  return;
		case INT_TYPE:
		  *((int *)p)=atoi((char *)item);
		  return;
		default:
		  fprintf(stderr,"Fatal error! need configuration %s",tag);
		  fclose(in);
		  exit(1);
		}
	}
}

int
read_conf(char *config_file_path)
{

	in=fopen(config_file_path,"rb");
	if( !in ){
		perror("fopen()");
		return -1;
	}
	get_tag_content("hostname",CHAR_TYPE,hostname);
	get_tag_content("username",CHAR_TYPE,username);
	get_tag_content("password",CHAR_TYPE,password);
	get_tag_content("database",CHAR_TYPE,database);
	get_tag_content("table",CHAR_TYPE,pydb_table);
	get_tag_content("port",INT_TYPE,&port);
	get_tag_content("max_latest_len",INT_TYPE,&max_latest_len);
	get_tag_content("max_words_len",INT_TYPE,&max_words_len);
#if 0
#define PRINTF(x) printf("[%s]\n",x)
	PRINTF(hostname);
	PRINTF(username);
	PRINTF(password);
	PRINTF(database);
	printf("[%d]\n",port);
	printf("[%d]\n",max_latest_len);
#endif
	fclose(in);
	return 0;
}











