#include <err.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "db_util.h"


#define GEN_PINYIN_TAB
#define GB_PINYIN_TAB

#ifdef GB_PINYIN_TAB
#include "../addpy/gbaddpy.dat"
#endif

#ifdef BIG5_PINYIN_TAB
#include "../addpy/b5addpy.dat"
#endif


MYSQL	pydb;
HANZI   **py;
extern  char pydb_table[MAX_CONFIG_VARS_LEN];

int
db_connect(	MYSQL *m,
		const char *host,
		const char *user,
		const char *password,
		const char *db,
		const int  port,
		const char *unix_socket,
		unsigned int client_flag)
{
	MYSQL *ret;

	ret=(MYSQL *)mysql_real_connect(	m,
						host,
						user,
						password,
						db,
						port,
						unix_socket,
						client_flag);
	if( ret == NULL){
		err(1,"thk: %s\n",mysql_error(m));
		return -1;
	}
#if 0	
	fprintf(stderr,"HOST     info: %s\n",mysql_get_host_info(ret));
	fprintf(stderr,"Client   info: %s\n",mysql_get_client_info());
	fprintf(stderr,"Protocal info: %d\n",mysql_get_proto_info(ret));
	fprintf(stderr,"Server   info: %s\n",mysql_get_server_info(ret));
	fprintf(stderr,"Stat     info:\n%s\n",mysql_stat(ret));
#endif
	return 0;
}

void
db_close(MYSQL *db)
{
	mysql_close(db);
}


float
is_have_one(register MYSQL *db,char *hanzi)
{
  static int  ret;
  static char sql[256];
  static MYSQL_RES *res;
  static float result;
#if 0
  static MYSQL_ROW row;
#endif


  sprintf(sql,"SELECT HIGH_PRIORITY freq FROM %s WHERE hanzi='%s'",pydb_table,hanzi);
  ret=mysql_real_query(db,sql,strlen(sql));
  if( ret)
    warn("error in mysql_real_query()\n");
  res=(MYSQL_RES *)mysql_store_result(db);
  if( !res)
    warn("Error in mysql_store_result()\n");
  ret=mysql_num_rows(res);
  if(ret){
#if 0
    row=mysql_fetch_row(res);
    result=(float)atof(row[0]);
#endif
    result=1;
  }else
    result=0;
  mysql_free_result(res);
  return result;
}



void
pydb_insert(register MYSQL *db,char *pinyin,char *hanzi,float freq,int priority)
{
  static int  ret;
  static char sql[256];
  static float result;

#define HIGH_PRIO_UPDATE "UPDATE %s SET freq=freq+%f WHERE hanzi='%s'"
#define LOW_PRIO_UPDATE "UPDATE LOW_PRIORITY %s SET freq=freq+%f WHERE hanzi='%s'"

#define HIGH_PRIO_INSERT "INSERT INTO %s (pinyin,hanzi,freq) VALUES('%s','%s',%f)"
#define LOW_PRIO_INSERT "INSERT LOW_PRIORITY INTO %s (pinyin,hanzi,freq) VALUES('%s','%s',%f)"


  result=is_have_one(db,hanzi);
  if( result ){
#if 0
    freq+=result;
#endif
    if(priority == HIGH_PRIORITY )
      sprintf(sql,HIGH_PRIO_UPDATE,pydb_table,freq,hanzi);
    else
      sprintf(sql,LOW_PRIO_UPDATE,pydb_table,freq,hanzi);
    ret=mysql_real_query(db,sql,strlen(sql));
    if( ret)
      warn("error in msyql_real_query(1)\n");
  }else{
    if( priority == HIGH_PRIORITY)
      sprintf(sql,HIGH_PRIO_INSERT,pydb_table,pinyin,hanzi,freq);
    else
      sprintf(sql,LOW_PRIO_INSERT,pydb_table,pinyin,hanzi,freq);
    ret=mysql_real_query(db,sql,strlen(sql));
    if(ret)
      warn("error in msyql_real_query(2)\n");
  }
}

void
pydb_insert_direct(register MYSQL *db,char *pinyin,char *hanzi,float freq)
{
  static char sql[256];
  int ret;

  sprintf(sql,LOW_PRIO_INSERT,pydb_table,pinyin,hanzi,freq);
  ret=mysql_real_query(db,sql,strlen(sql));
  if(ret)
    warn("error in msyql_real_query(2)\n");
}



void
init_py_ref_db(MYSQL *db,int need_add)
{
  register int i;
  char *p;
  int total;

  py=(HANZI **)calloc(MAX_PINYIN_SLOT,sizeof(struct _HANZI *));

  total=sizeof(hanzi)/sizeof(hanzi[0]);
  for(i=0;i<total;++i){
    if( hanzi[i].pinyin[0]!='\0'){
      py[GET_PY_INDEX(hanzi[i].hanzi)]=(HANZI *)&hanzi[i];
      for(p=hanzi[i].pinyin;!isdigit(*p);++p);
      *p='\0';
      if( need_add){
	pydb_insert_direct(db,hanzi[i].pinyin,hanzi[i].hanzi,1);
      }
    }
  }
}

/* 
 *  No need more than four HanZi characters? I'm not sure!
 */
int
add_item(register u_char_8 *p,int priority)
{
  register int tmp;
  int j,i,flag,ret;
  static char pinyin[256];
  static char hanzi[128];
  HANZI *h_p;

  tmp=0;
  for(i=0;i<MAX_HANZI_CHAR_NUMBER;++i){
    tmp=i*2;
    if( !(*(p+tmp) && *(p+tmp+1))){
      tmp=0;
      break;
    }
    if( IS_GB_CODE(p+tmp)){
      if(IS_GB_HZ(p+tmp)) {
	flag=1;
	pinyin[0]='\0';
	for (j = 0; j <= tmp; j += 2) {
	  ret=GET_PY_INDEX(p+j);
	  h_p=(HANZI *)py[ret];
	  if( h_p && h_p->pinyin){
	    strcat(pinyin, h_p->pinyin);
	  }else{ 
	    flag=0;
	    break;
	  }
	}
	if(flag){
	  strncpy(hanzi,p,tmp+2);
	  hanzi[tmp+2]='\0';
#if 0
	  printf("hanzi=[%s],pinyin=[%s]\n",hanzi,pinyin);
#endif
	  pydb_insert(&pydb,pinyin,hanzi,1,priority);
	}else{
	  return 2;
	}
      }else{
	return 2;
      }
    }else{
      break;
    }
  }
  if( tmp)
    return 2;
  else 
    return 1;
}
