#ifndef DB_UTIL_H
#define DB_UTIL_H

#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <mysql/mysql.h>
#include "local_types.h"



#define	BUF_LEN	512

#define PINYIN_REF_DB   "../gen_pytab/gb_pinyin.tab"

/*
 * it is seemed that use 4 HanZi characters static need too much 
 * resource than 2 HanZi characters static.
 */
#define MAX_HANZI_CHAR_NUMBER  7
#define HANZI_CHAR_WIDTH 2

/* the maximun length of pinyin of one HanZi character is 6 ,
 * so the max length of pinyin which need be used is x*6+1
 * for a phrase.
 */
#define MAX_SINGLE_HANZI_PINYIN_LEN 6
#define MAX_PINYIN_LEN  ((MAX_HANZI_CHAR_NUMBER)*6+1)

#define	GB_CODE_START	0xaf
#define GB_CODE_END	0xf8
#define	GB_CODE_START2	0xa0
#define GB_CODE_END2	0xff

#define LOW_PRIORITY     0
#define HIGH_PRIORITY    1

#define MAX_PINYIN_SLOT  ((0xff-0xa0)*256)

#define MAX_CONFIG_VARS_LEN  32

#define IS_GB_CODE(x)  ( (((u_char_8)*(x)) >0xa0 )		\
			 && ((u_char_8)*(x)< 0xf8 )		\
			 && (((u_char_8)*((x)+1))> 0xa0 )	\
			 && (((u_char_8)*((x)+1))< 0xff ))

#define IS_GB_HZ(x)    ( (((u_char_8)*(x)) > 0xaf ) 	\
		       && ((u_char_8)*(x)< 0xf8 )	\
		       && ((u_char_8)*((x)+1)> 0xa0 )	\
		       && ((u_char_8)*((x)+1)< 0xff ))

#define GET_PY_INDEX(x) (((u_char_8)(x)[0]-0xa1)*256+(u_char_8)(x)[1])

typedef struct _HANZI{
	unsigned char   hanzi[3];
	long            freq;
	char            pinyin[8];
}   HANZI;



int
db_connect(	MYSQL *m,
		const char *host,
		const char *user,
		const char *password,
		const char *db,
		const int  port,
		const char *unix_socket,
		unsigned int client_flag);
void   db_close(MYSQL *db);
float  is_have_one(MYSQL *db,char *hanzi);
void pydb_insert(register MYSQL *db,char *pinyin,char *hanzi,float freq,int priority);
void pydb_insert_direct(register MYSQL *db,char *pinyin,char *hanzi,float freq);
void init_py_ref_db(MYSQL *db,int need_add);
int add_item(register u_char_8 *p,int priority);
#endif



