
#include "utils.h"

void
unload_file(u_char_8 *p, u_int_32 file_length, int fd)
{
	int             ret;

	ret = munmap(p, file_length);
	if (ret == -1)
		warn("Error in munmap()\n");
	ret = close(fd);
	if (ret == -1)
		warn("Error in close()\n");
}

u_char_8  *
load_file(u_char_8 *file_path, u_int_32 *file_length, int *fd)
{

	struct stat     f_stat;
	u_char_8  *p;

	if (stat(file_path, &f_stat) < 0) {
		perror("stat()");
		return NULL;
	} else {
		*fd = open(file_path, O_RDONLY);
		if (*fd == -1) {
			fprintf(stderr, "open(%s)", file_path);
			return NULL;
		}
		p = (u_char_8 *) mmap(NULL, f_stat.st_size, PROT_READ,
					   MAP_PRIVATE, *fd, 0);
		if (p == MAP_FAILED) {
			perror("mmap()");
			return NULL;
		} else {
			*file_length = f_stat.st_size;
			return (u_char_8 *) p;
		}
	}
}

char *
get_tag_content(FILE *in,const char *tag,char *p)
{
	char buf[512];
	char tag_tmp[512];
	static char item[512];

	rewind(in);
	while(fgets(buf,sizeof(buf),in)){
		sscanf(	buf,"%s%s",tag_tmp,item);
		if( strcasecmp(tag,tag_tmp))
			continue;
		strcpy(p,item);
		return (char *)item;
	}
	return (char *)NULL;
}


